package se.chalmers.tdv.queue;

import java.util.Arrays;

public class Queue {

	private static final int INIT_CAPACITY = 5;
	private int[] buffer;
	private int start;
	private int size;

	public Queue() {
		buffer = new int[INIT_CAPACITY];
		size = 0;
		start = 0;
	}

	public boolean isEmpty() {
		return size == 0;
	}

	public Integer front() {
		if (size == 0)
			return null;
		return buffer[size - 1];
	}

	private void doubleArr() {
		int[] newBuffer = new int[buffer.length * 2];
		for (int i = 0; i < buffer.length; i++)
			newBuffer[i] = buffer[i];
		start = 0;
		buffer = newBuffer;
	}

	public void add(int value) {
		if (size == buffer.length - 1) {
			doubleArr();
		}
		size = size + 1;
		buffer[(start + size) % buffer.length] = value;
	}

	public void remove() {
		if (size == 0)
			return;
		size = size - 1;
		start = start + 1;
	}

	public String toString() {
		return "{size: " + size + " start: " + start + " buffer: "
				+ Arrays.toString(buffer) + "}";
	}

	public boolean equals(Object o) {
		if (!(o instanceof Queue))
			return false;
		Queue other = (Queue) o;
		
		// TODO implement /observational/ equivalence.
		
		return false;
	}

}
