package se.chalmers.tdv.queue;

public class QueueAction {

	public enum ActionType {
		ISEMPTY, ADD, FRONT, REMOVE, OUTPUT
	};

	public ActionType type;
	public Integer value;

	public QueueAction(ActionType type, Integer value) {
		this.type = type;
		this.value = value;
	}

	public String toString() {
		switch (this.type) {
		case ISEMPTY:
			return "isEmpty()";
		case ADD:
			return "add(" + this.value + ")";
		case FRONT:
			return "front()";
		case REMOVE:
			return "remove()";
		case OUTPUT:
			return "output(" + this.value + ")";
		default:
			throw new RuntimeException("Unknown action type.");
		}
	}

	public static QueueAction newIsEmptyAction() {
		return new QueueAction(ActionType.ISEMPTY, 0);
	}

	public static QueueAction newAddAction(Integer value) {
		return new QueueAction(ActionType.ADD, value);
	}

	public static QueueAction newFrontAction() {
		return new QueueAction(ActionType.FRONT, 0);
	}

	public static QueueAction newRemoveAction() {
		return new QueueAction(ActionType.REMOVE, 0);
	}

	public static QueueAction newOutputAction(Integer value) {
		return new QueueAction(ActionType.OUTPUT, value);
	}

}
