package se.chalmers.tdv.queue;

import java.util.LinkedList;
import java.util.Random;

import se.chalmers.tdv.testing.StatefulTest;
import se.chalmers.tdv.testing.StatefulTestCase;

public class QueueTestCase extends
		StatefulTestCase<Queue, QueueAction, Integer> {

	private Random rand = new Random();

	public QueueTestCase(
			StatefulTest<Queue, QueueAction, Integer> test) {
		super(test);
	}

	@Override
	public void perform(Queue queue, QueueAction action,
			LinkedList<Integer> out) {
		switch (action.type) {
		case ISEMPTY:
			out.add(queue.isEmpty() ? 1 : 0);
			break;
		case FRONT:
			out.add(queue.front());
			break;
		case OUTPUT:
			out.add(action.value);
			break;
		case REMOVE:
			queue.remove();
			break;
		case ADD:
			queue.add(action.value);
			break;
		}
	}

	@Override
	public void initialize() {
	}

	@Override
	public void setUp() {
		setObjects(new Queue(), new Queue());
	}

	@Override
	public QueueAction[] randomActions(int n) {
		QueueAction[] result = new QueueAction[n];
		for (int i = 0; i < n; i++) {
			switch (rand.nextInt(2)) {
			case 0:
				result[i] = QueueAction.newRemoveAction();
				break;
			case 1:
				result[i] = QueueAction.newAddAction(rand.nextInt(20));
				break;
			}
		}
		return result;
	}

}
